unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, DB, ZAbstractRODataset, ZDataset,
  ZConnection, Grids, DBGrids, Buttons;

type
  TformMenuPrincipal = class(TForm)
    conexionBD: TZConnection;
    tcTablespaces: TZReadOnlyQuery;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    txtUsuario: TEdit;
    txtContrasena: TEdit;
    txtServidor: TEdit;
    txtPuerto: TEdit;
    txtBD: TEdit;
    tab: TPageControl;
    tabTablespaces: TTabSheet;
    tabFicherosDatos: TTabSheet;
    tablaTablespaces: TDBGrid;
    tablaFicherosDatos: TDBGrid;
    bConectar: TBitBtn;
    dbTCTablespaces: TDataSource;
    dbTCFicheros: TDataSource;
    tcFicheros: TZReadOnlyQuery;
    tabConexiones: TTabSheet;
    tablaConexionesProgramas: TDBGrid;
    dbTCConexionesProgramas: TDataSource;
    tcConexionesProgramas: TZReadOnlyQuery;
    tabUsuarios: TTabSheet;
    tablaConexionesUsuarios: TDBGrid;
    tcConexionesUsuarios: TZReadOnlyQuery;
    dbTCConexionesUsuarios: TDataSource;
    procedure bConectarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

procedure TformMenuPrincipal.bConectarClick(Sender: TObject);
begin
  if not conexionBD.Connected then
  begin
    conexionBD.Disconnect;
    conexionBD.User := txtUsuario.Text;
    conexionBD.Password := txtContrasena.Text;
    conexionBD.Database := txtBD.Text;
    conexionBD.HostName := txtServidor.Text;
    conexionBD.Port := StrToInt(txtPuerto.Text);
    try
      conexionBD.Connect;
      bConectar.Caption := 'Desc&onectar';
    except
      bConectar.Caption := 'C&onectar';
    end;

    //Tablespaces
    tcTablespaces.Close;
    tcTablespaces.SQL.Clear;
    tcTablespaces.SQL.Add('Select t.tablespace_name  "Tablespace",  t.status "Estado",');
    tcTablespaces.SQL.Add('ROUND(MAX(d.bytes)/1024/1024,2) "MB Tamao",');
    tcTablespaces.SQL.Add('ROUND((MAX(d.bytes)/1024/1024) -');
    tcTablespaces.SQL.Add('(SUM(decode(f.bytes, NULL,0, f.bytes))/1024/1024),2) "MB Usados",');
    tcTablespaces.SQL.Add('ROUND(SUM(decode(f.bytes, NULL,0, f.bytes))/1024/1024,2) "MB Libres"');
    tcTablespaces.SQL.Add('FROM DBA_FREE_SPACE f, DBA_DATA_FILES d,  DBA_TABLESPACES t');
    tcTablespaces.SQL.Add('WHERE t.tablespace_name = d.tablespace_name  AND');
    tcTablespaces.SQL.Add('f.tablespace_name(+) = d.tablespace_name');
    tcTablespaces.SQL.Add('AND f.file_id(+) = d.file_id GROUP BY t.tablespace_name,');
    tcTablespaces.SQL.Add('d.file_name,   t.pct_increase, t.status ORDER BY 3 DESC');
    try
      tcTablespaces.Open;
    except
      raise;
    end;

    //Ficheros de datos
    tcFicheros.Close;
    tcFicheros.SQL.Clear;
    tcFicheros.SQL.Add('Select name Nombre, round (bytes/1024/1024, 2) Tamao, status Estado');
    tcFicheros.SQL.Add('from v$datafile');
    tcFicheros.SQL.Add('order by 2 DESC');
    try
      tcFicheros.Open;
      tablaFicherosDatos.Columns[0].Width := 400;      
    except
      raise;
    end;


    //Conexiones programas
    tcConexionesProgramas.Close;
    tcConexionesProgramas.SQL.Clear;
    tcConexionesProgramas.SQL.Add('select program Aplicacion, count(program) Numero_Sesiones');
    tcConexionesProgramas.SQL.Add('from v$session');
    tcConexionesProgramas.SQL.Add('group by program');
    tcConexionesProgramas.SQL.Add('order by Numero_Sesiones desc');
    try
      tcConexionesProgramas.Open;
    except
      raise;
    end;

    //Conexiones usuarios
    tcConexionesUsuarios.Close;
    tcConexionesUsuarios.SQL.Clear;
    tcConexionesUsuarios.SQL.Add('select osuser, username, machine, program');
    tcConexionesUsuarios.SQL.Add('from v$session');
    tcConexionesUsuarios.SQL.Add('order by osuser');
    try
      tcConexionesUsuarios.Open;
    except
      raise;
    end;  
  end
  else
  begin
    conexionBD.Disconnect;
    bConectar.Caption := 'C&onectar';
  end;
end;

procedure TformMenuPrincipal.FormShow(Sender: TObject);
begin
  tabTablespaces.Show;
end;

end.
